#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "verzeichnis.h"

int einfuegen(t_verzeichnis *pRoot, char vaterName[64], char neuerSohnName[64])
{
   t_verzeichnis *pVater, *pSohn;

   if( (pVater = suchen(pRoot,vaterName))== NULL)
   	return 0;
   if( (pSohn =(t_verzeichnis *)malloc(sizeof(t_verzeichnis))) == NULL)
   	return 0;

   strncpy(pSohn->name,neuerSohnName,64);
   pSohn->pSohn = NULL;
   pSohn->pNext = pVater->pSohn;
   pSohn->pVater = pVater;
   pVater->pSohn = pSohn;
   return 1;
}

int loeschen(t_verzeichnis *pRoot, char zuLoeschenName[64])
{
	t_verzeichnis *pZuLoeschender, *pVorgaenger;

   pZuLoeschender = suchen(pRoot,zuLoeschenName);
	if (pZuLoeschender == NULL || pZuLoeschender->pSohn != NULL) return 0;

   if (pZuLoeschender == pZuLoeschender->pVater->pSohn)
   	pZuLoeschender->pVater->pSohn = pZuLoeschender->pNext;
   else
   {
   	pVorgaenger = pZuLoeschender->pVater->pSohn;
      while (pVorgaenger->pNext != pZuLoeschender)
      	pVorgaenger = pVorgaenger->pNext;
      pVorgaenger->pNext = pZuLoeschender->pNext;
   }
   free(pZuLoeschender);
   return 1;
}


t_verzeichnis* suchen(t_verzeichnis *pRoot, char zuSuchenName[64])
{
	t_verzeichnis *pAktSohn, *pGefunden = NULL;
   pAktSohn = pRoot->pSohn;
   if( strcmp(zuSuchenName,pRoot->name) == 0)
   	return pRoot;
   while(pAktSohn != NULL && pGefunden == NULL)
   {
   	pGefunden = suchen(pAktSohn,zuSuchenName);
      pAktSohn = pAktSohn->pNext;
   }
   return pGefunden;
}

void ausgabe(t_verzeichnis *pRoot, int einrueckung)
{
	int i;
   t_verzeichnis *pAktSohn;
	for(i=0; i<einrueckung; ++i)
		printf(" ");
   printf("%s\n",pRoot->name);
      pAktSohn = pRoot->pSohn;
   while (pAktSohn != NULL)
   {
    	ausgabe(pAktSohn,einrueckung +2);
    	pAktSohn = pAktSohn->pNext;
   }
}

